Page MenuHomePhabricator

Enable VisualEditor for Chinese Wikipedia
Closed, ResolvedPublic

Description

After clarifying that enabling VisualEditor would not completely replace the wikitext editor, we reached a concensus. The discussion is seen here.

The concensus can be summarized as follows:

  1. Chinese Wikipedia shall have VisualEditor be moved out of Beta.
  2. For registered users, both visual editor edit tab and wikitext edit tab should be present by default.
  3. For IP users, no visual editor edit tab should be present. By clicking "edit" they should be directed to the wikitext editor. (Like how English Wikipedia is doing now)
Deployment plan
  • Verify the software's current configuration variables allow for the number of edit tabs, and the way they behave, to be different depending on peoples' account state (read: logged in vs. out) - Editing team
  • Deploy (Monday, Dec 6)
    • Proceed on the activation of the visual editor by default
    • Deploy Growth features in Dark mode
  • Deploy Growth features to all newcomers (Monday, Dec 13)

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

@Trizek-WMF Adding you FYI. Let me know when I can proceed.

Anoop removed a subscriber: Anoop.

@Urbanecm_WMF, we can proceed anytime. Would the following work? (If so, please copy it into the task description.)

  • Deploy (Monday, Dec 6)
    • Proceed on the activation of the visual editor by default
    • Deploy Growth features in Dark mode
  • Deploy Growth features to all newcomers (Monday, Dec 13)

We appreciate you filing this ticket, @MilkyDefer.

Before the Visual editor can be deployed in the ways the task description defines [i], the Editing Team will need to:

  • Verify the software's current configuration variables allow for the number of edit tabs, and the way they behave, to be different depending on peoples' account state (read: logged in vs. out)

@ppelberg, do you think your part can be done before Dec 6? I'm asking to adjust the schedule if needed; we won't suffer of a couple more days of patience. :)

Verify the software's current configuration variables allow for the number of edit tabs, and the way they behave, to be different depending on peoples' account state (read: logged in vs. out)

This is indeed possible. Details below:

  1. Chinese Wikipedia shall have VisualEditor be moved out of Beta.

This would be done by removing visualeditor-nondefault from zhwiki.yaml

  1. For registered users, both visual editor edit tab and wikitext edit tab should be present by default.

This will happen automatically on zh.wiki because it is not an SET wiki (VisualEditorUseSingleEditTab)

  1. For IP users, no visual editor edit tab should be present. By clicking "edit" they should be directed to the wikitext editor. (Like how English Wikipedia is doing now)

This would be VisualEditorDisableForAnons, which is currently only used by English and Spanish. Personally I think we should only be shrinking this list and not adding to it. If we do add to it, it should be with a plan to revise at a later date.

Change 744066 had a related patch set uploaded (by Esanders; author: Esanders):

[operations/mediawiki-config@master] Enable VE on zh.wiki, but only for logged-in users

https://gerrit.wikimedia.org/r/744066

Change 744066 merged by jenkins-bot:

[operations/mediawiki-config@master] Enable VE on zh.wiki, but only for logged-in users

https://gerrit.wikimedia.org/r/744066

Mentioned in SAL (#wikimedia-operations) [2021-12-09T12:14:42Z] <ladsgroup@deploy1002> Synchronized wmf-config/InitialiseSettings.php: Config: [[gerrit:744066|Enable VE on zh.wiki, but only for logged-in users (T296269)]] (duration: 01m 06s)

Mentioned in SAL (#wikimedia-operations) [2021-12-09T12:16:33Z] <ladsgroup@deploy1002> Synchronized dblists/visualeditor-nondefault.dblist: Config: [[gerrit:744066|Enable VE on zh.wiki, but only for logged-in users (T296269)]] (duration: 01m 05s)

Mentioned in SAL (#wikimedia-operations) [2021-12-09T12:23:31Z] <ladsgroup@deploy1002> Synchronized wmf-config/config/zhwiki.yaml: Config: [[gerrit:744066|Enable VE on zh.wiki, but only for logged-in users (T296269)]] (duration: 01m 05s)

Done.

For documentation:


Logged in users will now see two tabs:

image.png (2×3 px, 1 MB)
image.png (2×3 px, 1 MB)

…and they can disable the visual editor in preferences:

image.png (2×3 px, 374 KB)
image.png (2×3 px, 331 KB)

Logged out users only see one tab, as before:

image.png (2×3 px, 1 MB)
image.png (2×3 px, 1 MB)

…they have an option to switch to visual mode after opening the editor: (it's not remembered, they have to do it every time)

image.png (2×3 px, 562 KB)
image.png (2×3 px, 500 KB)

@matmarex Wait a sec, there is a dropdown menu in Editing section of user preferences in English Wikipedia that says, "Editing mode", where we can choose between "Remember my last editor", etc. I can say for sure it also exists in Japanese Wikipedia under the name "編集モード". That option is nowhere to be found in Chinese Wikipedia.

@MilkyDefer We didn't enable that option, because the default value for it is "Remember my last editor" (with a single edit tab), and you've asked for both edit tabs to be present. The current configuration for zhwiki is more similar to e.g. dewiki (German Wikipedia), where that dropdown is also missing.

How important is this to you? It would probably be possible to enable it with the default value of "Show me both editor tabs", but it'd require some more changes, and all of the different configurations are becoming difficult to maintain.

@matmarex We reached concensus after promising that option to be available, so it is part of our concensus. If maintaining that is hard, please prioritize "make this option available" over "default to showing two tabs"

I'll look into it, hopefully we can fix this later today.

Thank you. Sorry for the inconvenience.

Logged out users will be directed to VE when they hit redlinks, which is not expected. How about setting wmgVisualEditorIsSecondaryEditor?

That is indeed unexpected, and we'll definitely fix it today. Thanks for noticing it.

Change 745546 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[operations/mediawiki-config@master] VE on zh.wiki: Enable SET mode but defaulting to multi-tab

https://gerrit.wikimedia.org/r/745546

We've discussed in a meeting today what we can do about the "Editing mode" option. We don't want to enable it with a different default right now, since we haven't used that on any wiki before and we're not fully certain it will work as expected.

So, per T296269#7559604 (@MilkyDefer) we'll just enable it with the usual default: a single edit tab, "Remember my last editor", same as on English Wikipedia. I hope the Chinese Wikipedia community will be okay with that.

That configuration will also fix the issue with redlinks (@Lt2818), as that bug apparently doesn't affect the single-edit-tab mode.

Change 745546 merged by jenkins-bot:

[operations/mediawiki-config@master] VE on zh.wiki: Enable single-edit-tab mode

https://gerrit.wikimedia.org/r/745546

Mentioned in SAL (#wikimedia-operations) [2021-12-09T19:21:24Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: 4e6cba0d3590446bb02815b65ba1c4ae9ed7bfac: VE on zh.wiki: Enable single-edit-tab mode (T296269) (duration: 01m 05s)

Done.

That configuration will also fix the issue with redlinks (@Lt2818), as that bug apparently doesn't affect the single-edit-tab mode.

Actually, I was wrong here, it doesn't fix that issue. I'll submit another patch.

Change 745589 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/VisualEditor@master] Check VisualEditorDisableForAnons in getEditPageEditor()

https://gerrit.wikimedia.org/r/745589

Change 745385 had a related patch set uploaded (by Esanders; author: Esanders):

[operations/mediawiki-config@master] Revert \"VE on zh.wiki: Enable single-edit-tab mode\"

https://gerrit.wikimedia.org/r/745385

Looks like we ran into T264950 so I'm going to revert this afternoon's deployment as:

  • Currently we are showing VE to anons and this seems like the more serious issue
  • While we have a fix for that, I'd like to get a few more eyes on at as it involves the config used on enwiki/eswiki

Sorry for the confusion and hopefully we will have this resolved soon.

Change 745385 merged by jenkins-bot:

[operations/mediawiki-config@master] Revert \"VE on zh.wiki: Enable single-edit-tab mode\"

https://gerrit.wikimedia.org/r/745385

Mentioned in SAL (#wikimedia-operations) [2021-12-10T00:23:58Z] <cjming@deploy1002> Synchronized wmf-config/InitialiseSettings.php: Config: [[gerrit:745385|Revert "VE on zh.wiki: Enable single-edit-tab mode" (T296269)]] (duration: 00m 56s)

Well, may I ask if there are any updates on the current situation?

Our next steps are to review a fix for T264950, then redeploy the single edit tab config. The fix may have to wait until next week as we don't like to have things broken over the weekend.

Change 745589 merged by jenkins-bot:

[mediawiki/extensions/VisualEditor@master] Check VisualEditorDisableForAnons in getEditPageEditor()

https://gerrit.wikimedia.org/r/745589

By testing on my own server, I'm sure the correct configuration is

$wgVisualEditorUseSingleEditTab = true;  // Allow to user to change option in preference
$wgVisualEditorDisableForAnons = true;  // Disable for logged-out users
$wgDefaultUserOptions['visualeditor-tabs'] = 'multi-tab';  // Default to two tabs

Refer https://www.mediawiki.org/wiki/Extension:VisualEditor#Quick_configuration_guide "Single edit tab" and "Enabled for all to opt-in "

While the deployment of the visual editor is done, the Growth features will be deployed to Chinese Wikipedia.

Change 746912 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/VisualEditor@wmf/1.38.0-wmf.9] Check VisualEditorDisableForAnons in getEditPageEditor()

https://gerrit.wikimedia.org/r/746912

Change 746913 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/VisualEditor@wmf/1.38.0-wmf.12] Check VisualEditorDisableForAnons in getEditPageEditor()

https://gerrit.wikimedia.org/r/746913

Change 746914 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[operations/mediawiki-config@master] Re-apply \"VE on zh.wiki: Enable single-edit-tab mode\"

https://gerrit.wikimedia.org/r/746914

Change 746914 merged by jenkins-bot:

[operations/mediawiki-config@master] Re-apply \"VE on zh.wiki: Enable single-edit-tab mode\"

https://gerrit.wikimedia.org/r/746914

Change 746912 merged by jenkins-bot:

[mediawiki/extensions/VisualEditor@wmf/1.38.0-wmf.9] Check VisualEditorDisableForAnons in getEditPageEditor()

https://gerrit.wikimedia.org/r/746912

Change 746913 merged by jenkins-bot:

[mediawiki/extensions/VisualEditor@wmf/1.38.0-wmf.12] Check VisualEditorDisableForAnons in getEditPageEditor()

https://gerrit.wikimedia.org/r/746913

Change 746942 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Revert \"Re-apply \"VE on zh.wiki: Enable single-edit-tab mode\"\"

https://gerrit.wikimedia.org/r/746942

Change 746942 merged by jenkins-bot:

[operations/mediawiki-config@master] Revert \"Re-apply \"VE on zh.wiki: Enable single-edit-tab mode\"\"

https://gerrit.wikimedia.org/r/746942

Mentioned in SAL (#wikimedia-operations) [2021-12-13T19:39:00Z] <urbanecm@deploy1002> Synchronized php-1.38.0-wmf.9/extensions/VisualEditor/includes/VisualEditorHooks.php: 8144ab6577bdc93b4d81d5f8541437b746752610: Check VisualEditorDisableForAnons in getEditPageEditor() (T296269) (duration: 00m 56s)

Mentioned in SAL (#wikimedia-operations) [2021-12-13T19:40:15Z] <urbanecm@deploy1002> Synchronized php-1.38.0-wmf.12/extensions/VisualEditor/includes/VisualEditorHooks.php: fa01addb8ae29a97f6e141ec37a5e1204f0d7810: Check VisualEditorDisableForAnons in getEditPageEditor() (T296269) (duration: 00m 56s)

I tried deploying the single-edit-tab config again, and it was a failure – for logged out users, the edit tab was opening the visual editor, and I don't understand why at the moment.

Looks like I don't understand how the VisualEditorDisableForAnons configuration actually works.

Since our requirements seems to be identical to enwp (maybe, I suppose), would it be a good idea just simply mirroring enwp's related configurations?

enwp's configuration also sets the wikitext editor as the default, which is probably why logged-out users get the wikitext editor, but which is probably not desirable on other wikis.

@Xiplus @Lt2818 Well, setting wikitext editor as the default is what our community always arguing about, right?

The community prefers not to set VE as the default for logged-in users, so it's OK to mirror enwp's configurations.

The wikitext editor is always the default editor. We want to allow registered users to change "edit-tab" mode, and use "two tab" mode by default if possible.

Yes, our newest, revised concensus adds two additional main points:

  • If "enable SET mode" and "display two edit tabs" cannot both be fulfilled (either technically or refused), then just enable SET mode and set "remember last editor" to default.
  • Do NOT set Visual Editor as the default editor.

The wikitext editor is always the default editor.

Use wikitext editor for logged-out users. And use wikitext editor when visiting a red link for registered users.

Thank you for clarifying. I guess we can do the exact same configuration as English Wikipedia, then. I'll do that today, and I'm sorry about the bugs (and the misunderstandings).

Change 747190 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[operations/mediawiki-config@master] VE on zh.wiki: Enable single-edit-tab mode, and other config like en.wiki

https://gerrit.wikimedia.org/r/747190

Change 747190 merged by jenkins-bot:

[operations/mediawiki-config@master] VE on zh.wiki: Enable single-edit-tab mode, and other config like en.wiki

https://gerrit.wikimedia.org/r/747190

Mentioned in SAL (#wikimedia-operations) [2021-12-14T19:51:27Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: 40f0cff8da7c4484e1fe93b9d649fd03f462e434: VE on zh.wiki: Enable single-edit-tab mode, and other config like en.wiki (T296269) (duration: 00m 57s)

I think everything should be set up as you expected, for real this time. Please double-check.

I think everything should be set up as you expected, for real this time. Please double-check.

@MilkyDefer: the Editing Team is going to leave this task open until 22-December, unless we hear about any issues from you. Of course, if you notice problems after that, please just boldly re-open this task.